#include "RTC_SAMD51.h"
#include "DateTime.h"
# include"TFT_eSPI.h"
# include "Seeed_FS.h" //Including SD card library
# include"RawImage.h"  //Including image processing library

TFT_eSPI tft;
TFT_eSprite spr = TFT_eSprite(&tft);  //sprite

// Define the time intervals and corresponding actions
const int interval1StartHour = 1;
const int interval1StartMin = 46;
const int interval1EndHour = 1;
const int interval1EndMin = 47;

int hour, minute;


RTC_SAMD51 rtc;
char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
void setup()
{
    Serial.begin(115200);
    rtc.begin();

    DateTime now = DateTime(F(__DATE__), F(__TIME__));
     //!!! notic The year is limited to 2000-2099
    Serial.println("adjust time!");
    rtc.adjust(now);

    //Initialise SD card
    if(!SD.begin(SDCARD_SS_PIN, SDCARD_SPI)) {
        while (1);
    }
    tft.begin();
    tft.setRotation(3);
    drawImage<uint16_t>("5.bmp", 0, 0);
    delay(4000);
    drawImage<uint16_t>("3.bmp", 0, 0);
    delay(1500);
    drawImage<uint16_t>("4.bmp", 0, 0);
    delay(2500);
    
}

void loop()
{
  DateTime now = rtc.now();
  hour = now.hour();
  minute = now.minute();
  if ((hour >= interval1StartHour && minute >= interval1StartMin) && (hour < interval1EndHour || (hour == interval1EndHour && minute < interval1EndMin))){
    Serial.println("Test");
    alarm();
    alarm();
  } else{
    alarm();
  }

  real_time_display();
  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  Serial.print(now.second(), DEC);
  Serial.println();
  delay(1000);
}

void alarm(){
  drawImage<uint16_t>("6.bmp", 0, 0);
  delay(2000);
  drawImage<uint16_t>("7.bmp", 0, 0);
  delay(2000);
}

void real_time_display(){
  tft.setFreeFont(&FreeSansBoldOblique12pt7b);
  tft.setTextColor(TFT_BLACK);
  tft.drawString("time =     :   ", 10 , 200 , 1);

  spr.createSprite(35, 30);
  spr.fillSprite(0xFEC7);
  spr.setFreeFont(&FreeSansBoldOblique12pt7b);
  spr.setTextColor(TFT_BLACK);
  spr.drawNumber(hour, 0, 0, 1);
  spr.pushSprite(80, 200);
  spr.deleteSprite();

  spr.createSprite(35, 30);
  spr.fillSprite(0xFEC7);
  spr.setFreeFont(&FreeSansBoldOblique12pt7b);
  spr.setTextColor(TFT_BLACK);
  spr.drawNumber(minute, 0, 0, 1);
  spr.pushSprite(130, 200);
  spr.deleteSprite();
}
